<template>
    <div style="overflow-x: auto; box-shadow: 0 0 20px rgba(0, 0, 0, 0.15); border-radius: 5px; width: 100%">
        <div>
            <div class="ht-table__title">
                <h1>{{ title }}</h1>
            </div>
            <div class="ht-table__search">
                <ht-input label="search" v-model="searchValue"></ht-input>
            </div>
        </div>

        <table class="ht-table">
            <thead class="ht-table__head">
                <tr ref="tableHead">
                    <slot name="head"></slot>
                </tr>
            </thead>
            <tbody>
                <template v-for="(row, index) in activeItems">
                    <slot name="body" :item="{row: row, index:index}" v-if="index >= ((page - 1) * limit) && index < (page * limit) ">
                    </slot>
                </template>
            </tbody>
        </table>
        <div v-if="items.length >= limit">
            <ul class="ht-table__pagination">
                <li  v-for="index in Math.ceil(items.length / limit)" :key="index" class="ht-table__pagination__numbers" :class="{'active': page === index}" @click="changePage(index)">{{ index }}</li>
            </ul>
        </div>
    </div>
</template>

<script>
    import HtInput from '../form/ht-input';
    export default {
        name: 'ht-table',
        components: { HtInput },
        props: {
            title: {
                type: String
            },
            items: {
                type: Array
            },
            filters: {
                type: Array
            },
            limit: {
                type: Number,
                default: 100
            }
        },
        data() {
            return {
                searchValue: "",
                activeItems: this.items,
                sortActive: "",
                sortActiveIndex: "",
                sortDirection: "",
                page: 1
            }
        },
        methods: {
            changePage(page) {
                this.page = page;
            },
            sort(val, index) {
                if (val === this.sortActive) {
                    this.activeItems.reverse();
                    if (this.sortDirection === "up") {
                        this.sortDirection = "down"
                    }else {
                        this.sortDirection = "up"
                    }
                    return this.sortDirection;
                }
                this.sortActive = val;

                this.activeItems = this.activeItems.sort(function(a, b) {
                    return a[val] - b[val];
                }).sort(function(a, b) {
                    let titleA = a[val];
                    let titleB = b[val];
                    if (typeof a[val] === 'string') {
                        titleA = a[val].toLowerCase();
                        titleB = b[val].toLowerCase();
                    }
                    if (titleA < titleB) return -1;
                    if (titleA > titleB) return 1;
                    return 0;
                }).sort(function(a, b) {
                    let dateA = new Date(a[val]), dateB = new Date(b[val]);
                    return dateA - dateB;
                });

                this.sortActiveIndex = index;
                this.sortDirection = "up";
                return this.sortDirection;
            }
        },
        watch: {
            searchValue(val) {
                this.sortDirection = "";
                this.sortActive = "";
                this.sortActiveIndex = "";
                if (val.length === 0) {
                    this.activeItems = this.items;
                    return "";
                }

                this.activeItems = this.items.filter((item) => {
                    let itemIncluded = false;
                    for (const itemKey of this.filters) {
                        if (typeof item[itemKey] === 'string') {
                            if (item[itemKey].toLowerCase().includes(val.toLowerCase())) {
                                itemIncluded = true
                            }
                        }else {
                            if (item[itemKey].toString().includes(val.toString())) {
                                itemIncluded = true
                            }
                        }
                    }
                    if (itemIncluded) {
                        return item
                    }
                    // return this.searchRecipesCategory(item);

                });
            },
            items() {
                this.activeItems = this.items
                this.searchValue = ""
            }
        }
    };
</script>

<style scoped>

</style>
